{-
Abstract syntax for the language. This will be translated from the abstract syntax generated by bnfc.

The goal of this abstract syntax is to combine similar statements/expressions to be grouped together to simplify type checking and execution.

This abstract syntax is far from ready so far, but it gives a hint of what we are planning.
-}
module Abs (
	Ident
	,Stm(...)
	,Exp(...)
	,Op(...)
	,BOp(...)
) where

newtype Ident = Ident String deriving (Eq,Ord,Show)

type Program = [Stm]

data Stm = 
	  SNoop
	| SDecl Type Ident Exp
	| SExp Exp
	| SBlock [Stm]
	| SIf Exp Stm Stm
	| SWhile Exp Stm
	| SPrint Exp
	deriving (Eq,Ord,Show)

data Exp =
	  EOp Op Exp Exp
	| EBOp BOp Exp Exp
	| EVar Ident
	| EInt Integer
	| EBool Bool
	| ExpT Type Exp
	| ENeg Exp
	| ERead Type
	deriving (Eq,Ord,Show)

data Op = Plus | Minus | Div | Times 
data BOp = Lt | Gt | Eq | Neq | ELt | EGt

data Type =
	  TInt
	| TBool
	deriving (Eq,Ord,Show)
